'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _PropTypes = require('react-router/lib/PropTypes');

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _ErrorPage = require('./ErrorPage');

var _ErrorPage2 = _interopRequireDefault(_ErrorPage);

var _RecordTitleBarContainer = require('../../containers/record/RecordTitleBarContainer');

var _RecordTitleBarContainer2 = _interopRequireDefault(_RecordTitleBarContainer);

var _RecordBrowser = require('../record/RecordBrowser');

var _RecordBrowser2 = _interopRequireDefault(_RecordBrowser);

var _RecordSideBar = require('../record/RecordSideBar');

var _RecordSideBar2 = _interopRequireDefault(_RecordSideBar);

var _configHelpers = require('../../helpers/configHelpers');

var _RecordPage = require('../../../styles/cspace-ui/RecordPage.css');

var _RecordPage2 = _interopRequireDefault(_RecordPage);

var _PageBody = require('../../../styles/cspace-ui/PageBody.css');

var _PageBody2 = _interopRequireDefault(_PageBody);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  location: _PropTypes.locationShape,
  params: _react.PropTypes.shape({
    recordType: _react.PropTypes.string.isRequired,
    path1: _react.PropTypes.string,
    path2: _react.PropTypes.string,
    path3: _react.PropTypes.string
  }).isRequired,
  readRecord: _react.PropTypes.func,
  router: _PropTypes.routerShape
};

var contextTypes = {
  config: _react.PropTypes.object.isRequired
};

var RecordPage = function (_Component) {
  _inherits(RecordPage, _Component);

  function RecordPage() {
    _classCallCheck(this, RecordPage);

    var _this = _possibleConstructorReturn(this, (RecordPage.__proto__ || Object.getPrototypeOf(RecordPage)).call(this));

    _this.handleShowRelated = _this.handleShowRelated.bind(_this);
    return _this;
  }

  _createClass(RecordPage, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.initRecord();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      var params = this.getParams(this.props);
      var prevParams = this.getParams(prevProps);

      var csid = params.csid;
      var prevCsid = prevParams.csid;


      if (csid !== prevCsid) {
        this.initRecord();
      }
    }
  }, {
    key: 'getParams',
    value: function getParams(props) {
      var _props$params = props.params,
          recordType = _props$params.recordType,
          path1 = _props$params.path1,
          path2 = _props$params.path2,
          path3 = _props$params.path3;
      var config = this.context.config;


      var vocabulary = void 0;
      var csid = void 0;
      var relatedRecordType = void 0;
      var relatedCsid = void 0;

      var recordTypeConfig = (0, _get2.default)(config, ['recordTypes', recordType]);

      if (recordTypeConfig) {
        var serviceType = (0, _get2.default)(recordTypeConfig, ['serviceConfig', 'serviceType']);

        if (serviceType === 'authority') {
          vocabulary = path1;
          csid = path2;
          relatedRecordType = path3;
        } else {
          csid = path1;
          relatedRecordType = path2;
          relatedCsid = path3;
        }
      }

      return {
        recordType: recordType,
        vocabulary: vocabulary,
        csid: csid,
        relatedRecordType: relatedRecordType,
        relatedCsid: relatedCsid
      };
    }
  }, {
    key: 'initRecord',
    value: function initRecord() {
      var readRecord = this.props.readRecord;
      var config = this.context.config;

      var _getParams = this.getParams(this.props),
          recordType = _getParams.recordType,
          vocabulary = _getParams.vocabulary,
          csid = _getParams.csid;

      var normalizedCsid = csid === 'new' ? '' : csid;

      if (normalizedCsid && readRecord) {
        var recordTypeConfig = (0, _get2.default)(config, ['recordTypes', recordType]);

        var vocabularyConfig = vocabulary ? (0, _get2.default)(recordTypeConfig, ['vocabularies', vocabulary]) : undefined;

        readRecord(recordTypeConfig, vocabularyConfig, normalizedCsid);
      }
    }
  }, {
    key: 'handleShowRelated',
    value: function handleShowRelated(relatedRecordType, relatedCsid) {
      var _getParams2 = this.getParams(this.props),
          recordType = _getParams2.recordType,
          vocabulary = _getParams2.vocabulary,
          csid = _getParams2.csid;

      var router = this.props.router;


      var path = [recordType, vocabulary, csid, relatedRecordType, relatedCsid].filter(function (part) {
        return !!part;
      }).join('/');

      router.replace('/record/' + path);
    }
  }, {
    key: 'render',
    value: function render() {
      var location = this.props.location;
      var config = this.context.config;

      var _getParams3 = this.getParams(this.props),
          recordType = _getParams3.recordType,
          vocabulary = _getParams3.vocabulary,
          csid = _getParams3.csid,
          relatedRecordType = _getParams3.relatedRecordType,
          relatedCsid = _getParams3.relatedCsid;

      var cloneCsid = location.query.clone;
      var normalizedCsid = csid === 'new' ? '' : csid || '';
      var normalizedRelatedCsid = relatedCsid === 'new' ? '' : relatedCsid;

      var validation = (0, _configHelpers.validateLocation)(config, {
        recordType: recordType,
        vocabulary: vocabulary,
        relatedRecordType: relatedRecordType,
        csid: normalizedCsid,
        relatedCsid: normalizedRelatedCsid
      });

      if (validation.error) {
        return _react2.default.createElement(_ErrorPage2.default, { error: validation.error });
      }

      return _react2.default.createElement(
        'div',
        { className: _RecordPage2.default.common },
        _react2.default.createElement(_RecordTitleBarContainer2.default, { csid: normalizedCsid, recordType: recordType }),
        _react2.default.createElement(
          'div',
          { className: _PageBody2.default.common },
          _react2.default.createElement(_RecordBrowser2.default, {
            cloneCsid: cloneCsid,
            csid: normalizedCsid,
            recordType: recordType,
            relatedCsid: normalizedRelatedCsid,
            relatedRecordType: relatedRecordType,
            vocabulary: vocabulary,
            config: config,
            onShowRelated: this.handleShowRelated
          }),
          _react2.default.createElement(_RecordSideBar2.default, {
            csid: normalizedCsid,
            recordType: recordType,
            vocabulary: vocabulary,
            config: config
          })
        )
      );
    }
  }]);

  return RecordPage;
}(_react.Component);

exports.default = RecordPage;


RecordPage.propTypes = propTypes;
RecordPage.contextTypes = contextTypes;