'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.searchName = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

var _reactRouter = require('react-router');

var _PropTypes = require('react-router/lib/PropTypes');

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _ErrorPage = require('./ErrorPage');

var _ErrorPage2 = _interopRequireDefault(_ErrorPage);

var _SearchResultTitleBar = require('../search/SearchResultTitleBar');

var _SearchResultTitleBar2 = _interopRequireDefault(_SearchResultTitleBar);

var _PageSizeChooser = require('../search/PageSizeChooser');

var _PageSizeChooser2 = _interopRequireDefault(_PageSizeChooser);

var _Pager = require('../search/Pager');

var _Pager2 = _interopRequireDefault(_Pager);

var _SearchResultTableContainer = require('../../containers/search/SearchResultTableContainer');

var _SearchResultTableContainer2 = _interopRequireDefault(_SearchResultTableContainer);

var _configHelpers = require('../../helpers/configHelpers');

var _SearchResultPage = require('../../../styles/cspace-ui/SearchResultPage.css');

var _SearchResultPage2 = _interopRequireDefault(_SearchResultPage);

var _SearchResultTableHeader = require('../../../styles/cspace-ui/SearchResultTableHeader.css');

var _SearchResultTableHeader2 = _interopRequireDefault(_SearchResultTableHeader);

var _PageBody = require('../../../styles/cspace-ui/PageBody.css');

var _PageBody2 = _interopRequireDefault(_PageBody);

var _SearchResultSidebar = require('../../../styles/cspace-ui/SearchResultSidebar.css');

var _SearchResultSidebar2 = _interopRequireDefault(_SearchResultSidebar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var messages = (0, _reactIntl.defineMessages)({
  error: {
    'id': 'searchResultPage.error',
    'defaultMessage': 'Error: {message}'
  },
  editSearch: {
    'id': 'searchResultPage.editSearch',
    'defaultMessage': 'Revise search'
  }
});

var searchName = exports.searchName = 'searchResultPage';
// FIXME: Make default page size configurable
var defaultPageSize = 20;

var propTypes = {
  location: _PropTypes.locationShape,
  params: _react.PropTypes.objectOf(_react.PropTypes.string),
  preferredPageSize: _react.PropTypes.number,
  search: _react.PropTypes.func,
  setPreferredPageSize: _react.PropTypes.func,
  setSearchPageAdvanced: _react.PropTypes.func,
  setSearchPageKeyword: _react.PropTypes.func
};

var contextTypes = {
  config: _react.PropTypes.object.isRequired,
  router: _PropTypes.routerShape
};

var SearchResultPage = function (_Component) {
  _inherits(SearchResultPage, _Component);

  function SearchResultPage() {
    _classCallCheck(this, SearchResultPage);

    var _this = _possibleConstructorReturn(this, (SearchResultPage.__proto__ || Object.getPrototypeOf(SearchResultPage)).call(this));

    _this.renderFooter = _this.renderFooter.bind(_this);
    _this.renderHeader = _this.renderHeader.bind(_this);
    _this.handleEditSearchLinkClick = _this.handleEditSearchLinkClick.bind(_this);
    _this.handlePageChange = _this.handlePageChange.bind(_this);
    _this.handlePageSizeChange = _this.handlePageSizeChange.bind(_this);
    _this.handleSortChange = _this.handleSortChange.bind(_this);
    return _this;
  }

  _createClass(SearchResultPage, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (!this.normalizeQuery()) {
        var _props = this.props,
            location = _props.location,
            setPreferredPageSize = _props.setPreferredPageSize;


        if (setPreferredPageSize) {
          var query = location.query;


          setPreferredPageSize(parseInt(query.size, 10));
        }

        this.search();
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (this.props.params.recordType !== prevProps.params.recordType || this.props.params.vocabulary !== prevProps.params.vocabulary || this.props.params.csid !== prevProps.params.csid || this.props.params.subresource !== prevProps.params.subresource || this.props.location.query !== prevProps.location.query) {
        if (!this.normalizeQuery()) {
          var _props2 = this.props,
              location = _props2.location,
              setPreferredPageSize = _props2.setPreferredPageSize;


          if (setPreferredPageSize) {
            var query = location.query;


            setPreferredPageSize(parseInt(query.size, 10));
          }

          this.search();
        }
      }
    }
  }, {
    key: 'getSearchDescriptor',
    value: function getSearchDescriptor() {
      // FIXME: Make the search descriptor consistently an Immutable. Currently only the advanced
      // search condition is an Immutable. The whole search descriptor gets converted to an Immutable
      // when stored in the Redux store, but components expect it to be an object (except for the
      // advanced search condition, which is always Immutable). This is confusing.

      // FIXME: Refactor this into a wrapper component that calculates the search descriptor from
      // location and params, and passes it into a child. This will eliminate the multiple calls to
      // this method from the various render methods in this class.

      var _props3 = this.props,
          location = _props3.location,
          params = _props3.params;


      var searchQuery = Object.assign({}, location.query, {
        p: parseInt(location.query.p, 10) - 1,
        size: parseInt(location.query.size, 10)
      });

      var advancedSearchCondition = location.query.as;

      if (advancedSearchCondition) {
        searchQuery.as = _immutable2.default.fromJS(JSON.parse(advancedSearchCondition));
      }

      var searchDescriptor = {
        searchQuery: searchQuery
      };

      ['recordType', 'vocabulary', 'csid', 'subresource'].forEach(function (param) {
        var value = params[param];

        if (typeof value !== 'undefined') {
          searchDescriptor[param] = value;
        }
      });

      return searchDescriptor;
    }
  }, {
    key: 'getListType',
    value: function getListType(searchDescriptor) {
      if (searchDescriptor) {
        var subresource = searchDescriptor.subresource;


        if (subresource) {
          var config = this.context.config;


          return (0, _get2.default)(config, ['subresources', subresource, 'listType']);
        }
      }

      return 'common';
    }
  }, {
    key: 'normalizeQuery',
    value: function normalizeQuery() {
      var _props4 = this.props,
          location = _props4.location,
          preferredPageSize = _props4.preferredPageSize;
      var query = location.query;
      var router = this.context.router;


      if (router) {
        var normalizedQueryParams = {};

        var pageSize = parseInt(query.size, 10);

        if (isNaN(pageSize) || pageSize < 1) {
          var normalizedPageSize = preferredPageSize || defaultPageSize;

          normalizedQueryParams.size = normalizedPageSize.toString();
        } else if (pageSize > 2500) {
          // Services layer max is 2500
          normalizedQueryParams.size = '2500';
        } else if (pageSize.toString() !== query.size) {
          normalizedQueryParams.size = pageSize.toString();
        }

        var pageNum = parseInt(query.p, 10);

        if (isNaN(pageNum) || pageNum < 1) {
          normalizedQueryParams.p = '1';
        } else if (pageNum.toString() !== query.p) {
          normalizedQueryParams.p = pageNum.toString();
        }

        if (Object.keys(normalizedQueryParams).length > 0) {
          var newQuery = Object.assign({}, query, normalizedQueryParams);

          router.replace({
            pathname: location.pathname,
            query: newQuery
          });

          return true;
        }
      }

      return false;
    }
  }, {
    key: 'handleEditSearchLinkClick',
    value: function handleEditSearchLinkClick() {
      // Transfer this search descriptor's search criteria to advanced search.

      var _props5 = this.props,
          setSearchPageAdvanced = _props5.setSearchPageAdvanced,
          setSearchPageKeyword = _props5.setSearchPageKeyword;


      if (setSearchPageKeyword || setSearchPageAdvanced) {
        var searchDescriptor = this.getSearchDescriptor();
        var searchQuery = searchDescriptor.searchQuery;


        if (setSearchPageKeyword) {
          var kw = searchQuery.kw;


          setSearchPageKeyword(kw);
        }

        if (setSearchPageAdvanced) {
          var advancedSearchCondition = searchQuery.as;


          setSearchPageAdvanced(advancedSearchCondition);
        }
      }
    }
  }, {
    key: 'handlePageChange',
    value: function handlePageChange(pageNum) {
      var location = this.props.location;
      var router = this.context.router;


      if (router) {
        router.push({
          pathname: location.pathname,
          query: Object.assign({}, location.query, {
            p: (pageNum + 1).toString()
          })
        });
      }
    }
  }, {
    key: 'handlePageSizeChange',
    value: function handlePageSizeChange(pageSize) {
      var _props6 = this.props,
          location = _props6.location,
          setPreferredPageSize = _props6.setPreferredPageSize;
      var router = this.context.router;


      if (setPreferredPageSize) {
        setPreferredPageSize(pageSize);
      }

      if (router) {
        router.push({
          pathname: location.pathname,
          query: Object.assign({}, location.query, {
            p: '1',
            size: pageSize.toString()
          })
        });
      }
    }
  }, {
    key: 'handleSortChange',
    value: function handleSortChange(sort) {
      var location = this.props.location;
      var router = this.context.router;


      if (router) {
        router.push({
          pathname: location.pathname,
          query: Object.assign({}, location.query, {
            sort: sort
          })
        });
      }
    }
  }, {
    key: 'search',
    value: function search() {
      var search = this.props.search;
      var config = this.context.config;


      var searchDescriptor = this.getSearchDescriptor();
      var listType = this.getListType(searchDescriptor);

      if (search) {
        search(config, searchName, searchDescriptor, listType);
      }
    }
  }, {
    key: 'renderEditLink',
    value: function renderEditLink() {
      var searchDescriptor = this.getSearchDescriptor();

      var recordType = searchDescriptor.recordType,
          vocabulary = searchDescriptor.vocabulary;


      var vocabularyPath = vocabulary ? '/' + vocabulary : '';
      var path = '/search/' + recordType + vocabularyPath;

      return _react2.default.createElement(
        _reactRouter.Link,
        { to: path, onClick: this.handleEditSearchLinkClick },
        _react2.default.createElement(_reactIntl.FormattedMessage, messages.editSearch)
      );
    }
  }, {
    key: 'renderHeader',
    value: function renderHeader(_ref) {
      var searchError = _ref.searchError,
          searchResult = _ref.searchResult;

      if (searchError) {
        // FIXME: Make a proper error page
        var _message = searchError.get('code') || '';

        return _react2.default.createElement(
          'header',
          { className: _SearchResultTableHeader2.default.error },
          _react2.default.createElement(_reactIntl.FormattedMessage, _extends({}, messages.error, { values: { message: _message } })),
          _react2.default.createElement(
            'p',
            null,
            this.renderEditLink()
          )
        );
      }

      var pageSize = null;
      var message = null;

      if (searchResult) {
        var config = this.context.config;


        var searchDescriptor = this.getSearchDescriptor();
        var listType = this.getListType(searchDescriptor);
        var listTypeConfig = config.listTypes[listType];
        var listNodeName = listTypeConfig.listNodeName;


        var list = searchResult.get(listNodeName);
        var totalItems = parseInt(list.get('totalItems'), 10);

        if (isNaN(totalItems)) {
          message = _react2.default.createElement(_reactIntl.FormattedMessage, listTypeConfig.messages.searching);
        } else {
          var pageNum = parseInt(list.get('pageNum'), 10);

          pageSize = parseInt(list.get('pageSize'), 10);

          var startNum = pageNum * pageSize + 1;
          var endNum = Math.min(pageNum * pageSize + pageSize, totalItems);

          message = _react2.default.createElement(_reactIntl.FormattedMessage, _extends({}, listTypeConfig.messages.resultCount, {
            values: {
              totalItems: totalItems,
              startNum: startNum,
              endNum: endNum
            }
          }));
        }
      }

      if (pageSize === null) {
        var _searchDescriptor = this.getSearchDescriptor();

        pageSize = _searchDescriptor.searchQuery.size;
      }

      var content = _react2.default.createElement(
        'div',
        null,
        message,
        message ? ' | ' : '',
        this.renderEditLink()
      );

      var pageSizeChooser = _react2.default.createElement(_PageSizeChooser2.default, {
        pageSize: pageSize,
        onPageSizeChange: this.handlePageSizeChange
      });

      return _react2.default.createElement(
        'header',
        { className: _SearchResultTableHeader2.default.normal },
        content,
        pageSizeChooser
      );
    }
  }, {
    key: 'renderFooter',
    value: function renderFooter(_ref2) {
      var searchResult = _ref2.searchResult;

      if (searchResult) {
        var config = this.context.config;


        var searchDescriptor = this.getSearchDescriptor();
        var listType = this.getListType(searchDescriptor);
        var listTypeConfig = config.listTypes[listType];
        var listNodeName = listTypeConfig.listNodeName;


        var list = searchResult.get(listNodeName);

        var totalItems = parseInt(list.get('totalItems'), 10);
        var pageNum = parseInt(list.get('pageNum'), 10);
        var pageSize = parseInt(list.get('pageSize'), 10);
        var lastPage = Math.max(0, isNaN(totalItems) ? 0 : Math.ceil(totalItems / pageSize) - 1);

        return _react2.default.createElement(
          'footer',
          null,
          _react2.default.createElement(_Pager2.default, {
            currentPage: pageNum,
            lastPage: lastPage,
            pageSize: pageSize,
            onPageChange: this.handlePageChange,
            onPageSizeChange: this.handlePageSizeChange
          })
        );
      }

      return null;
    }
  }, {
    key: 'render',
    value: function render() {
      var config = this.context.config;


      var searchDescriptor = this.getSearchDescriptor();
      var listType = this.getListType(searchDescriptor);

      var recordType = searchDescriptor.recordType,
          vocabulary = searchDescriptor.vocabulary,
          csid = searchDescriptor.csid,
          subresource = searchDescriptor.subresource;


      var validation = (0, _configHelpers.validateLocation)(config, { recordType: recordType, vocabulary: vocabulary, csid: csid, subresource: subresource });

      if (validation.error) {
        return _react2.default.createElement(_ErrorPage2.default, { error: validation.error });
      }

      return _react2.default.createElement(
        'div',
        { className: _SearchResultPage2.default.common },
        _react2.default.createElement(_SearchResultTitleBar2.default, {
          config: config,
          searchDescriptor: searchDescriptor,
          searchName: searchName
        }),
        _react2.default.createElement(
          'div',
          { className: _PageBody2.default.common },
          _react2.default.createElement(_SearchResultTableContainer2.default, {
            config: config,
            listType: listType,
            searchName: searchName,
            searchDescriptor: searchDescriptor,
            recordType: recordType,
            renderHeader: this.renderHeader,
            renderFooter: this.renderFooter,
            onSortChange: this.handleSortChange
          }),
          _react2.default.createElement('div', { className: _SearchResultSidebar2.default.common })
        )
      );
    }
  }]);

  return SearchResultPage;
}(_react.Component);

exports.default = SearchResultPage;


SearchResultPage.propTypes = propTypes;
SearchResultPage.contextTypes = contextTypes;