'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRouter = require('react-router');

var _PropTypes = require('react-router/lib/PropTypes');

var _RecordBrowserNavBarContainer = require('../../containers/record/RecordBrowserNavBarContainer');

var _RecordBrowserNavBarContainer2 = _interopRequireDefault(_RecordBrowserNavBarContainer);

var _RecordEditorContainer = require('../../containers/record/RecordEditorContainer');

var _RecordEditorContainer2 = _interopRequireDefault(_RecordEditorContainer);

var _RelatedRecordBrowser = require('./RelatedRecordBrowser');

var _RelatedRecordBrowser2 = _interopRequireDefault(_RelatedRecordBrowser);

var _RecordBrowser = require('../../../styles/cspace-ui/RecordBrowser.css');

var _RecordBrowser2 = _interopRequireDefault(_RecordBrowser);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  cloneCsid: _react.PropTypes.string,
  config: _react.PropTypes.object,
  csid: _react.PropTypes.string,
  recordType: _react.PropTypes.string,
  relatedCsid: _react.PropTypes.string,
  relatedRecordType: _react.PropTypes.string,
  router: _PropTypes.routerShape,
  vocabulary: _react.PropTypes.string,
  onShowRelated: _react.PropTypes.func
};

var RecordBrowser = function (_Component) {
  _inherits(RecordBrowser, _Component);

  function RecordBrowser() {
    _classCallCheck(this, RecordBrowser);

    var _this = _possibleConstructorReturn(this, (RecordBrowser.__proto__ || Object.getPrototypeOf(RecordBrowser)).call(this));

    _this.cloneRecord = _this.cloneRecord.bind(_this);
    _this.handleRecordCreated = _this.handleRecordCreated.bind(_this);
    return _this;
  }

  _createClass(RecordBrowser, [{
    key: 'cloneRecord',
    value: function cloneRecord() {
      var _props = this.props,
          csid = _props.csid,
          recordType = _props.recordType,
          vocabulary = _props.vocabulary,
          router = _props.router;


      var path = [recordType, vocabulary].filter(function (part) {
        return !!part;
      }).join('/');

      router.push({
        pathname: '/record/' + path,
        query: {
          clone: csid
        }
      });
    }
  }, {
    key: 'handleRecordCreated',
    value: function handleRecordCreated(newRecordCsid) {
      var _props2 = this.props,
          recordType = _props2.recordType,
          vocabulary = _props2.vocabulary,
          router = _props2.router;


      var path = [recordType, vocabulary, newRecordCsid].filter(function (part) {
        return !!part;
      }).join('/');

      router.replace('/record/' + path);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          cloneCsid = _props3.cloneCsid,
          config = _props3.config,
          csid = _props3.csid,
          recordType = _props3.recordType,
          relatedCsid = _props3.relatedCsid,
          relatedRecordType = _props3.relatedRecordType,
          vocabulary = _props3.vocabulary,
          onShowRelated = _props3.onShowRelated;


      var content = void 0;

      if (relatedRecordType) {
        content = _react2.default.createElement(_RelatedRecordBrowser2.default, {
          cloneCsid: cloneCsid,
          config: config,
          recordType: recordType,
          csid: csid,
          relatedRecordType: relatedRecordType,
          relatedCsid: relatedCsid,
          onShowRelated: onShowRelated
        });
      } else {
        content = _react2.default.createElement(_RecordEditorContainer2.default, {
          cloneCsid: cloneCsid,
          config: config,
          csid: csid,
          recordType: recordType,
          vocabulary: vocabulary,
          clone: this.cloneRecord,
          onRecordCreated: this.handleRecordCreated
        });
      }

      return _react2.default.createElement(
        'div',
        { className: _RecordBrowser2.default.common },
        _react2.default.createElement(_RecordBrowserNavBarContainer2.default, {
          config: config,
          csid: csid,
          recordType: recordType,
          relatedRecordType: relatedRecordType,
          onSelect: onShowRelated
        }),
        content
      );
    }
  }]);

  return RecordBrowser;
}(_react.Component);

RecordBrowser.propTypes = propTypes;

exports.default = (0, _reactRouter.withRouter)(RecordBrowser);