'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = RecordButtonBar;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _CloneButton = require('./CloneButton');

var _CloneButton2 = _interopRequireDefault(_CloneButton);

var _SaveButton = require('./SaveButton');

var _SaveButton2 = _interopRequireDefault(_SaveButton);

var _RevertButton = require('./RevertButton');

var _RevertButton2 = _interopRequireDefault(_RevertButton);

var _ButtonBar = require('../../../styles/cspace-ui/ButtonBar.css');

var _ButtonBar2 = _interopRequireDefault(_ButtonBar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
  csid: _react.PropTypes.string,
  isModified: _react.PropTypes.bool,
  isSavePending: _react.PropTypes.bool,
  onCloneButtonClick: _react.PropTypes.func,
  onRevertButtonClick: _react.PropTypes.func,
  onSaveButtonClick: _react.PropTypes.func
};

function RecordButtonBar(props) {
  var csid = props.csid,
      isModified = props.isModified,
      isSavePending = props.isSavePending,
      onCloneButtonClick = props.onCloneButtonClick,
      onRevertButtonClick = props.onRevertButtonClick,
      onSaveButtonClick = props.onSaveButtonClick;


  return _react2.default.createElement(
    'div',
    { className: _ButtonBar2.default.common },
    _react2.default.createElement(_SaveButton2.default, {
      isModified: isModified,
      isSavePending: isSavePending,
      onClick: onSaveButtonClick
    }),
    _react2.default.createElement(_CloneButton2.default, {
      csid: csid,
      isModified: isModified,
      isSavePending: isSavePending,
      onClick: onCloneButtonClick
    }),
    _react2.default.createElement(_RevertButton2.default, {
      isModified: isModified,
      isSavePending: isSavePending,
      onClick: onRevertButtonClick
    })
  );
}

RecordButtonBar.propTypes = propTypes;