'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = RelateButton;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

var _cspaceInput = require('cspace-input');

var _RelateButton = require('../../../styles/cspace-ui/RelateButton.css');

var _RelateButton2 = _interopRequireDefault(_RelateButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Button = _cspaceInput.components.Button;


var messages = (0, _reactIntl.defineMessages)({
  label: {
    'id': 'relateButton.label',
    'defaultMessage': 'Relate existing...'
  }
});

var propTypes = {
  onClick: _react.PropTypes.func
};

function RelateButton(props) {
  var onClick = props.onClick;


  return _react2.default.createElement(
    Button,
    {
      className: _RelateButton2.default.common,
      icon: true,
      name: 'relate',
      onClick: onClick
    },
    _react2.default.createElement(_reactIntl.FormattedMessage, messages.label)
  );
}

RelateButton.propTypes = propTypes;