'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _reactIntl = require('react-intl');

var _recordDataHelpers = require('../../helpers/recordDataHelpers');

var _SearchPanelContainer = require('../../containers/search/SearchPanelContainer');

var _SearchPanelContainer2 = _interopRequireDefault(_SearchPanelContainer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var messages = (0, _reactIntl.defineMessages)({
  title: {
    'id': 'relatedMediaPanel.title',
    'defaultMessage': 'Related Media'
  }
});

var getSearchDescriptor = function getSearchDescriptor(relatedCsid, updatedTimestamp) {
  return {
    recordType: 'media',
    searchQuery: {
      rel: relatedCsid,
      p: 0,
      size: 5
    },
    seqID: updatedTimestamp
  };
};

var propTypes = {
  config: _react.PropTypes.object,
  csid: _react.PropTypes.string,
  recordData: _react.PropTypes.instanceOf(_immutable2.default.Map),
  recordType: _react.PropTypes.string
};

var RelatedMediaPanel = function (_Component) {
  _inherits(RelatedMediaPanel, _Component);

  function RelatedMediaPanel(props) {
    _classCallCheck(this, RelatedMediaPanel);

    var _this = _possibleConstructorReturn(this, (RelatedMediaPanel.__proto__ || Object.getPrototypeOf(RelatedMediaPanel)).call(this, props));

    _this.handleSearchDescriptorChange = _this.handleSearchDescriptorChange.bind(_this);

    var _this$props = _this.props,
        csid = _this$props.csid,
        recordData = _this$props.recordData;


    _this.state = {
      searchDescriptor: getSearchDescriptor(csid, (0, _recordDataHelpers.getUpdatedTimestamp)(recordData))
    };
    return _this;
  }

  _createClass(RelatedMediaPanel, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _props = this.props,
          csid = _props.csid,
          recordData = _props.recordData;


      var updatedTimestamp = (0, _recordDataHelpers.getUpdatedTimestamp)(recordData);

      var nextCsid = nextProps.csid,
          nextRecordData = nextProps.recordData;


      var nextUpdatedTimestamp = (0, _recordDataHelpers.getUpdatedTimestamp)(nextRecordData);

      if (nextCsid !== csid || nextUpdatedTimestamp !== updatedTimestamp) {
        this.setState({
          searchDescriptor: getSearchDescriptor(nextCsid, nextUpdatedTimestamp)
        });
      }
    }
  }, {
    key: 'handleSearchDescriptorChange',
    value: function handleSearchDescriptorChange(searchDescriptor) {
      this.setState({
        searchDescriptor: searchDescriptor
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          config = _props2.config,
          csid = _props2.csid,
          recordType = _props2.recordType;
      var searchDescriptor = this.state.searchDescriptor;


      if (!searchDescriptor.seqID) {
        // Don't render until after the record has loaded.

        return null;
      }

      return _react2.default.createElement(_SearchPanelContainer2.default, {
        collapsed: true,
        columnSetName: 'narrow',
        config: config,
        csid: csid,
        name: 'relatedMediaPanel',
        searchDescriptor: searchDescriptor,
        recordType: recordType,
        title: _react2.default.createElement(_reactIntl.FormattedMessage, messages.title),
        onSearchDescriptorChange: this.handleSearchDescriptorChange
      });
    }
  }]);

  return RelatedMediaPanel;
}(_react.Component);

exports.default = RelatedMediaPanel;


RelatedMediaPanel.propTypes = propTypes;