'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = QuickSearchForm;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

var _cspaceInput = require('cspace-input');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var QuickSearchInput = _cspaceInput.components.QuickSearchInput;


var messages = (0, _reactIntl.defineMessages)({
  quickSearchPlaceholder: {
    'id': 'quickSearchForm.placeholder',
    'defaultMessage': 'Search'
  }
});

var propTypes = {
  intl: _reactIntl.intlShape,
  config: _react.PropTypes.object
};

function QuickSearchForm(props) {
  var intl = props.intl,
      config = props.config,
      remainingProps = _objectWithoutProperties(props, ['intl', 'config']);

  var formatRecordTypeLabel = function formatRecordTypeLabel(name, recordTypeConfig) {
    return intl.formatMessage(recordTypeConfig.messages.record.collectionName);
  };

  var formatVocabularyLabel = function formatVocabularyLabel(name, vocabularyConfig) {
    return intl.formatMessage(vocabularyConfig.messages.name);
  };

  return _react2.default.createElement(
    'fieldset',
    null,
    _react2.default.createElement(QuickSearchInput, _extends({}, remainingProps, {
      formatRecordTypeLabel: formatRecordTypeLabel,
      formatVocabularyLabel: formatVocabularyLabel,
      placeholder: intl.formatMessage(messages.quickSearchPlaceholder),
      recordTypes: config.recordTypes
    }))
  );
}

QuickSearchForm.propTypes = propTypes;