'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = SearchField;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Field = require('../record/Field');

var _Field2 = _interopRequireDefault(_Field);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var propTypes = {
  parentPath: _react.PropTypes.arrayOf(_react.PropTypes.string),
  name: _react.PropTypes.string,
  value: _react.PropTypes.string,
  readOnly: _react.PropTypes.bool,
  onCommit: _react.PropTypes.func
};

function SearchField(props) {
  var parentPath = props.parentPath,
      name = props.name,
      value = props.value,
      readOnly = props.readOnly,
      onCommit = props.onCommit;


  return _react2.default.createElement(_Field2.default, {
    label: undefined,
    parentPath: parentPath,
    name: name,
    readOnly: readOnly,
    repeating: false,
    value: value,
    viewType: 'search',
    onCommit: onCommit
    // Do not show quick add on autocomplete inputs.
    , showQuickAdd: false
  });
}

SearchField.propTypes = propTypes;