'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.searchName = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactIntl = require('react-intl');

var _immutable = require('immutable');

var _immutable2 = _interopRequireDefault(_immutable);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _cspaceLayout = require('cspace-layout');

var _SearchForm = require('./SearchForm');

var _SearchForm2 = _interopRequireDefault(_SearchForm);

var _PageSizeChooser = require('./PageSizeChooser');

var _PageSizeChooser2 = _interopRequireDefault(_PageSizeChooser);

var _Pager = require('./Pager');

var _Pager2 = _interopRequireDefault(_Pager);

var _SearchToRelateTitleBar = require('./SearchToRelateTitleBar');

var _SearchToRelateTitleBar2 = _interopRequireDefault(_SearchToRelateTitleBar);

var _SearchResultTableContainer = require('../../containers/search/SearchResultTableContainer');

var _SearchResultTableContainer2 = _interopRequireDefault(_SearchResultTableContainer);

var _searchHelpers = require('../../helpers/searchHelpers');

var _SearchToRelateModal = require('../../../styles/cspace-ui/SearchToRelateModal.css');

var _SearchToRelateModal2 = _interopRequireDefault(_SearchToRelateModal);

var _SearchResultTableHeader = require('../../../styles/cspace-ui/SearchResultTableHeader.css');

var _SearchResultTableHeader2 = _interopRequireDefault(_SearchResultTableHeader);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var messages = (0, _reactIntl.defineMessages)({
  label: {
    'id': 'searchToRelateModal.label',
    'defaultMessage': 'Search to Relate'
  },
  cancel: {
    'id': 'searchToRelateModal.cancel',
    'defaultMessage': 'Cancel'
  },
  relate: {
    'id': 'searchToRelateModal.relate',
    'defaultMessage': 'Relate selected'
  },
  search: {
    'id': 'searchToRelateModal.search',
    'defaultMessage': 'Search'
  },
  error: {
    'id': 'searchToRelateModal.error',
    'defaultMessage': 'Error: {message}'
  },
  editSearch: {
    'id': 'searchToRelateModal.editSearch',
    'defaultMessage': 'Revise search'
  },
  relating: {
    'id': 'searchToRelateModal.relating',
    'defaultMessage': 'Relating...'
  }
});

var searchName = exports.searchName = 'searchToRelate';

var listType = 'common';
// FIXME: Make default page size configurable
var defaultPageSize = 20;

var handleItemClick = function handleItemClick() {
  return false;
};

var propTypes = {
  config: _react.PropTypes.object,
  intl: _reactIntl.intlShape,
  isOpen: _react.PropTypes.bool,
  keywordValue: _react.PropTypes.string,
  defaultRecordTypeValue: _react.PropTypes.string,
  recordTypeValue: _react.PropTypes.string,
  vocabularyValue: _react.PropTypes.string,
  advancedSearchCondition: _react.PropTypes.object,
  preferredPageSize: _react.PropTypes.number,
  selectedItems: _react.PropTypes.instanceOf(_immutable2.default.Map),
  subjectCsid: _react.PropTypes.string,
  subjectRecordType: _react.PropTypes.string,
  onAdvancedSearchConditionCommit: _react.PropTypes.func,
  onKeywordCommit: _react.PropTypes.func,
  onRecordTypeCommit: _react.PropTypes.func,
  onVocabularyCommit: _react.PropTypes.func,
  onCloseButtonClick: _react.PropTypes.func,
  onCancelButtonClick: _react.PropTypes.func,
  onItemSelectChange: _react.PropTypes.func,
  onRelationsCreated: _react.PropTypes.func,
  clearSearchResults: _react.PropTypes.func,
  createRelations: _react.PropTypes.func,
  parentSelector: _react.PropTypes.func,
  search: _react.PropTypes.func,
  setPreferredPageSize: _react.PropTypes.func
};

var SearchToRelateModal = function (_Component) {
  _inherits(SearchToRelateModal, _Component);

  function SearchToRelateModal() {
    _classCallCheck(this, SearchToRelateModal);

    var _this = _possibleConstructorReturn(this, (SearchToRelateModal.__proto__ || Object.getPrototypeOf(SearchToRelateModal)).call(this));

    _this.handleAcceptButtonClick = _this.handleAcceptButtonClick.bind(_this);
    _this.handleCancelButtonClick = _this.handleCancelButtonClick.bind(_this);
    _this.handleCheckboxChange = _this.handleCheckboxChange.bind(_this);
    _this.handleCloseButtonClick = _this.handleCloseButtonClick.bind(_this);
    _this.handleEditSearchLinkClick = _this.handleEditSearchLinkClick.bind(_this);
    _this.handleFormSearch = _this.handleFormSearch.bind(_this);
    _this.handlePageChange = _this.handlePageChange.bind(_this);
    _this.handlePageSizeChange = _this.handlePageSizeChange.bind(_this);
    _this.handleSortChange = _this.handleSortChange.bind(_this);
    _this.renderCheckbox = _this.renderCheckbox.bind(_this);
    _this.renderSearchResultTableHeader = _this.renderSearchResultTableHeader.bind(_this);
    _this.renderSearchResultTableFooter = _this.renderSearchResultTableFooter.bind(_this);

    _this.state = {
      isSearchInitiated: false,
      pageNum: 0,
      sort: null
    };
    return _this;
  }

  _createClass(SearchToRelateModal, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          defaultRecordTypeValue = _props.defaultRecordTypeValue,
          onRecordTypeCommit = _props.onRecordTypeCommit;


      if (onRecordTypeCommit) {
        onRecordTypeCommit(defaultRecordTypeValue);

        // TODO: If search to relate is ever used on authorities, need to set the default vocabulary
        // if this is an authority record type, and vocabularyValue is not provided.
      }
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var isOpen = this.props.isOpen;
      var nextIsOpen = nextProps.isOpen;


      if (isOpen && !nextIsOpen) {
        // Closing.

        var clearSearchResults = this.props.clearSearchResults;


        if (clearSearchResults) {
          clearSearchResults(searchName);
        }

        this.setState({
          isRelating: false,
          isSearchInitiated: false,
          pageNum: 0
        });
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps, prevState) {
      var _props2 = this.props,
          defaultRecordTypeValue = _props2.defaultRecordTypeValue,
          onRecordTypeCommit = _props2.onRecordTypeCommit;
      var prevDefaultRecordTypeValue = prevProps.defaultRecordTypeValue;


      if (onRecordTypeCommit && defaultRecordTypeValue !== prevDefaultRecordTypeValue) {
        onRecordTypeCommit(defaultRecordTypeValue);

        // TODO: If search to relate is ever used on authorities, need to set the default vocabulary
        // if this is an authority record type, and vocabularyValue is not provided.
      }

      var _state = this.state,
          isSearchInitiated = _state.isSearchInitiated,
          pageNum = _state.pageNum,
          sort = _state.sort;


      if (isSearchInitiated) {
        var _props3 = this.props,
            recordTypeValue = _props3.recordTypeValue,
            vocabularyValue = _props3.vocabularyValue,
            advancedSearchCondition = _props3.advancedSearchCondition,
            preferredPageSize = _props3.preferredPageSize;
        var prevRecordTypeValue = prevProps.recordTypeValue,
            prevVocabularyValue = prevProps.vocabularyValue,
            prevAdvancedSearchCondition = prevProps.advancedSearchCondition,
            prevPreferredPageSize = prevProps.preferredPageSize;
        var prevPageNum = prevState.pageNum,
            prevSort = prevState.sort;


        if (recordTypeValue !== prevRecordTypeValue || vocabularyValue !== prevVocabularyValue || !(0, _isEqual2.default)(advancedSearchCondition, prevAdvancedSearchCondition) || preferredPageSize !== prevPreferredPageSize || pageNum !== prevPageNum || sort !== prevSort) {
          this.search();
        }
      }
    }
  }, {
    key: 'getSearchDescriptor',
    value: function getSearchDescriptor() {
      var _props4 = this.props,
          config = _props4.config,
          recordType = _props4.recordTypeValue,
          vocabulary = _props4.vocabularyValue,
          keyword = _props4.keywordValue,
          advancedSearchCondition = _props4.advancedSearchCondition,
          preferredPageSize = _props4.preferredPageSize,
          subjectCsid = _props4.subjectCsid;
      var _state2 = this.state,
          pageNum = _state2.pageNum,
          sort = _state2.sort;


      var pageSize = preferredPageSize || defaultPageSize;

      var searchQuery = {
        mkRtSbj: subjectCsid,
        p: pageNum,
        size: pageSize
      };

      if (sort) {
        searchQuery.sort = sort;
      }

      var kw = keyword ? keyword.trim() : '';

      if (kw) {
        searchQuery.kw = kw;
      }

      var fields = (0, _get2.default)(config, ['recordTypes', recordType, 'fields']);
      var condition = (0, _searchHelpers.normalizeCondition)(fields, advancedSearchCondition);

      if (condition) {
        searchQuery.as = condition;
      }

      return {
        recordType: recordType,
        vocabulary: vocabulary,
        searchQuery: searchQuery
      };
    }
  }, {
    key: 'relate',
    value: function relate() {
      var _props5 = this.props,
          selectedItems = _props5.selectedItems,
          subjectCsid = _props5.subjectCsid,
          subjectRecordType = _props5.subjectRecordType,
          createRelations = _props5.createRelations,
          onRelationsCreated = _props5.onRelationsCreated;


      var searchDescriptor = this.getSearchDescriptor();

      this.setState({
        isRelating: true,
        isSearchInitiated: false
      });

      var subject = {
        csid: subjectCsid,
        type: subjectRecordType
      };

      var objects = selectedItems.valueSeq().map(function (item) {
        return {
          csid: item.get('csid'),
          type: searchDescriptor.recordType };
      }).toJS();

      createRelations(subject, objects, 'affects').then(function () {
        if (onRelationsCreated) {
          onRelationsCreated();
        }
      });
    }
  }, {
    key: 'search',
    value: function search() {
      var _props6 = this.props,
          config = _props6.config,
          search = _props6.search;


      if (search) {
        var searchDescriptor = this.getSearchDescriptor();

        search(config, searchName, searchDescriptor);

        this.setState({
          isSearchInitiated: true
        });
      }
    }
  }, {
    key: 'handleAcceptButtonClick',
    value: function handleAcceptButtonClick() {
      var isSearchInitiated = this.state.isSearchInitiated;


      if (isSearchInitiated) {
        this.relate();
      } else {
        this.search();
      }
    }
  }, {
    key: 'handleCancelButtonClick',
    value: function handleCancelButtonClick(event) {
      var onCancelButtonClick = this.props.onCancelButtonClick;


      if (onCancelButtonClick) {
        onCancelButtonClick(event);
      }
    }
  }, {
    key: 'handleCloseButtonClick',
    value: function handleCloseButtonClick(event) {
      var onCloseButtonClick = this.props.onCloseButtonClick;


      if (onCloseButtonClick) {
        onCloseButtonClick(event);
      }
    }
  }, {
    key: 'handleEditSearchLinkClick',
    value: function handleEditSearchLinkClick() {
      var clearSearchResults = this.props.clearSearchResults;


      if (clearSearchResults) {
        clearSearchResults(searchName);
      }

      this.setState({
        isSearchInitiated: false
      });
    }
  }, {
    key: 'handleFormSearch',
    value: function handleFormSearch() {
      this.search();
    }
  }, {
    key: 'handleCheckboxChange',
    value: function handleCheckboxChange(event) {
      var checkbox = event.target;
      var index = parseInt(checkbox.name, 10);
      var checked = checkbox.checked;

      var _props7 = this.props,
          config = _props7.config,
          onItemSelectChange = _props7.onItemSelectChange;


      if (onItemSelectChange) {
        var searchDescriptor = this.getSearchDescriptor();

        onItemSelectChange(config, searchName, searchDescriptor, listType, index, checked);
      }
    }
  }, {
    key: 'handlePageChange',
    value: function handlePageChange(pageNum) {
      this.setState({
        pageNum: pageNum
      });
    }
  }, {
    key: 'handlePageSizeChange',
    value: function handlePageSizeChange(pageSize) {
      var setPreferredPageSize = this.props.setPreferredPageSize;


      var normalizedPageSize = void 0;

      if (isNaN(pageSize) || pageSize < 1) {
        normalizedPageSize = 0;
      } else if (pageSize > 2500) {
        normalizedPageSize = 2500;
      } else {
        normalizedPageSize = pageSize;
      }

      if (setPreferredPageSize) {
        this.setState({
          pageNum: 0
        });

        setPreferredPageSize(normalizedPageSize);
      }
    }
  }, {
    key: 'handleSortChange',
    value: function handleSortChange(sort) {
      this.setState({
        sort: sort
      });
    }
  }, {
    key: 'renderCheckbox',
    value: function renderCheckbox(_ref) {
      var rowData = _ref.rowData,
          rowIndex = _ref.rowIndex;
      var _props8 = this.props,
          subjectCsid = _props8.subjectCsid,
          selectedItems = _props8.selectedItems;


      if (rowData.get('related') === 'true') {
        return null;
      }

      var itemCsid = rowData.get('csid');

      if (itemCsid === subjectCsid) {
        return null;
      }

      var selected = selectedItems ? selectedItems.has(itemCsid) : false;

      return _react2.default.createElement('input', {
        checked: selected,
        name: rowIndex,
        type: 'checkbox',
        onChange: this.handleCheckboxChange
      });
    }
  }, {
    key: 'renderSearchForm',
    value: function renderSearchForm() {
      var _props9 = this.props,
          config = _props9.config,
          intl = _props9.intl,
          keywordValue = _props9.keywordValue,
          recordTypeValue = _props9.recordTypeValue,
          vocabularyValue = _props9.vocabularyValue,
          advancedSearchCondition = _props9.advancedSearchCondition,
          onAdvancedSearchConditionCommit = _props9.onAdvancedSearchConditionCommit,
          onKeywordCommit = _props9.onKeywordCommit,
          onRecordTypeCommit = _props9.onRecordTypeCommit,
          onVocabularyCommit = _props9.onVocabularyCommit;


      return _react2.default.createElement(_SearchForm2.default, {
        config: config,
        intl: intl,
        recordTypeValue: recordTypeValue,
        vocabularyValue: vocabularyValue,
        keywordValue: keywordValue,
        advancedSearchCondition: advancedSearchCondition,
        recordTypeInputReadOnly: true,
        onAdvancedSearchConditionCommit: onAdvancedSearchConditionCommit,
        onKeywordCommit: onKeywordCommit,
        onRecordTypeCommit: onRecordTypeCommit,
        onVocabularyCommit: onVocabularyCommit,
        onSearch: this.handleFormSearch
      });
    }
  }, {
    key: 'renderEditLink',
    value: function renderEditLink() {
      return _react2.default.createElement(
        'button',
        { onClick: this.handleEditSearchLinkClick },
        _react2.default.createElement(_reactIntl.FormattedMessage, messages.editSearch)
      );
    }
  }, {
    key: 'renderSearchResultTableHeader',
    value: function renderSearchResultTableHeader(_ref2) {
      var searchError = _ref2.searchError,
          searchResult = _ref2.searchResult;

      if (searchError) {
        // FIXME: Make a proper error page
        var _message = searchError.get('code') || '';

        return _react2.default.createElement(
          'header',
          { className: _SearchResultTableHeader2.default.error },
          _react2.default.createElement(_reactIntl.FormattedMessage, _extends({}, messages.error, { values: { message: _message } })),
          _react2.default.createElement(
            'p',
            null,
            this.renderEditLink()
          )
        );
      }

      var message = null;
      var pageSize = null;

      if (searchResult) {
        var config = this.props.config;


        var listTypeConfig = config.listTypes[listType];
        var listNodeName = listTypeConfig.listNodeName;


        var list = searchResult.get(listNodeName);
        var totalItems = parseInt(list.get('totalItems'), 10);

        if (isNaN(totalItems)) {
          message = _react2.default.createElement(_reactIntl.FormattedMessage, listTypeConfig.messages.searching);
        } else {
          var pageNum = parseInt(list.get('pageNum'), 10);

          pageSize = parseInt(list.get('pageSize'), 10);

          var startNum = pageNum * pageSize + 1;
          var endNum = Math.min(pageNum * pageSize + pageSize, totalItems);

          message = _react2.default.createElement(_reactIntl.FormattedMessage, _extends({}, listTypeConfig.messages.resultCount, {
            values: {
              totalItems: totalItems,
              startNum: startNum,
              endNum: endNum
            }
          }));
        }
      }

      if (pageSize === null) {
        var searchDescriptor = this.getSearchDescriptor();

        pageSize = searchDescriptor.searchQuery.size;
      }

      var content = _react2.default.createElement(
        'div',
        null,
        message,
        message ? ' | ' : '',
        this.renderEditLink()
      );

      var pageSizeChooser = _react2.default.createElement(_PageSizeChooser2.default, {
        pageSize: pageSize,
        onPageSizeChange: this.handlePageSizeChange
      });

      return _react2.default.createElement(
        'header',
        { className: _SearchResultTableHeader2.default.normal },
        content,
        pageSizeChooser
      );
    }
  }, {
    key: 'renderSearchResultTableFooter',
    value: function renderSearchResultTableFooter(_ref3) {
      var searchResult = _ref3.searchResult;
      var config = this.props.config;


      if (searchResult) {
        var listTypeConfig = config.listTypes[listType];
        var list = searchResult.get(listTypeConfig.listNodeName);

        var totalItems = parseInt(list.get('totalItems'), 10);
        var pageSize = parseInt(list.get('pageSize'), 10);
        var pageNum = parseInt(list.get('pageNum'), 10);
        var lastPage = Math.max(0, isNaN(totalItems) ? 0 : Math.ceil(totalItems / pageSize) - 1);

        return _react2.default.createElement(
          'footer',
          null,
          _react2.default.createElement(_Pager2.default, {
            currentPage: pageNum,
            lastPage: lastPage,
            pageSize: pageSize,
            onPageChange: this.handlePageChange,
            onPageSizeChange: this.handlePageSizeChange
          })
        );
      }

      return null;
    }
  }, {
    key: 'renderSearchResultTable',
    value: function renderSearchResultTable() {
      var _props10 = this.props,
          config = _props10.config,
          recordTypeValue = _props10.recordTypeValue;


      var searchDescriptor = this.getSearchDescriptor();

      return _react2.default.createElement(_SearchResultTableContainer2.default, {
        config: config,
        listType: listType,
        recordType: recordTypeValue,
        searchName: searchName,
        searchDescriptor: searchDescriptor,
        showCheckboxColumn: true,
        renderCheckbox: this.renderCheckbox,
        renderHeader: this.renderSearchResultTableHeader,
        renderFooter: this.renderSearchResultTableFooter,
        onItemClick: handleItemClick,
        onSortChange: this.handleSortChange
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props11 = this.props,
          config = _props11.config,
          intl = _props11.intl,
          isOpen = _props11.isOpen,
          recordTypeValue = _props11.recordTypeValue,
          selectedItems = _props11.selectedItems,
          parentSelector = _props11.parentSelector;
      var _state3 = this.state,
          isRelating = _state3.isRelating,
          isSearchInitiated = _state3.isSearchInitiated;


      var content = void 0;

      if (isRelating) {
        content = _react2.default.createElement(
          'p',
          null,
          _react2.default.createElement(_reactIntl.FormattedMessage, messages.relating)
        );
      } else if (isSearchInitiated) {
        content = this.renderSearchResultTable();
      } else {
        content = this.renderSearchForm();
      }

      var acceptButtonMessage = isSearchInitiated ? messages.relate : messages.search;

      var acceptButtonDisabled = isRelating || isSearchInitiated && (!selectedItems || selectedItems.size < 1);

      var cancelButtonDisabled = isRelating;

      var searchDescriptor = this.getSearchDescriptor();

      var title = _react2.default.createElement(_SearchToRelateTitleBar2.default, {
        config: config,
        isSearchInitiated: isSearchInitiated,
        recordType: recordTypeValue,
        searchDescriptor: searchDescriptor
      });

      return _react2.default.createElement(
        _cspaceLayout.Modal,
        {
          className: _SearchToRelateModal2.default.common,
          contentLabel: intl.formatMessage(messages.label),
          title: title,
          isOpen: isOpen,
          showCloseButton: !isRelating,
          closeButtonClassName: 'material-icons',
          closeButtonLabel: 'close',
          cancelButtonLabel: intl.formatMessage(messages.cancel),
          cancelButtonDisabled: cancelButtonDisabled,
          acceptButtonLabel: intl.formatMessage(acceptButtonMessage),
          acceptButtonDisabled: acceptButtonDisabled,
          parentSelector: parentSelector,
          onAcceptButtonClick: this.handleAcceptButtonClick,
          onCancelButtonClick: this.handleCancelButtonClick,
          onCloseButtonClick: this.handleCloseButtonClick
        },
        content
      );
    }
  }]);

  return SearchToRelateModal;
}(_react.Component);

SearchToRelateModal.propTypes = propTypes;

exports.default = (0, _reactIntl.injectIntl)(SearchToRelateModal);