'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.default = withCsid;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function withCsid(BaseComponent) {
  function WithCsid(props, context) {
    var csid = context.csid;


    return _react2.default.createElement(BaseComponent, _extends({}, props, {
      csid: csid
    }));
  }

  WithCsid.contextTypes = {
    csid: _react.PropTypes.string
  };

  return WithCsid;
}