'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactIntl = require('react-intl');

var _formatHelpers = require('../../../helpers/formatHelpers');

exports.default = {
  default: [{
    name: 'docName',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.authority.default.docName',
        'defaultMessage': 'Item'
      }
    }),
    width: 200
  }, {
    name: 'docType',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.authority.default.docType',
        'defaultMessage': 'Type'
      }
    }),
    formatValue: function formatValue(value, formatterContext) {
      return (0, _formatHelpers.formatServiceObjectName)(value, formatterContext);
    },
    width: 150
  }, {
    name: 'vocabulary',
    dataKey: 'refName',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.authority.default.vocabulary',
        'defaultMessage': 'Vocabulary'
      }
    }),
    formatValue: function formatValue(value, formatterContext) {
      return (0, _formatHelpers.formatRefNameAsVocabularyName)(value, formatterContext);
    },
    width: 150
  }, {
    name: 'updatedAt',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.authority.default.updatedAt',
        'defaultMessage': 'Updated'
      }
    }),
    formatValue: _formatHelpers.formatTimestamp,
    sortBy: 'collectionspace_core:updatedAt',
    width: 150
  }]
};