'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

exports.default = function (pluginContext) {
  return function (cspaceDocument) {
    var _pluginContext$record = pluginContext.recordDataHelpers,
        deepGet = _pluginContext$record.deepGet,
        getPart = _pluginContext$record.getPart;


    if (!cspaceDocument) {
      return '';
    }

    var common = getPart(cspaceDocument, 'collectionobjects_common');

    if (!common) {
      return '';
    }

    var objectNumber = common.get('objectNumber');
    var title = deepGet(common, ['titleGroupList', 'titleGroup', 0, 'title']);

    return [objectNumber, title].filter(function (part) {
      return !!part;
    }).join(' – ');
  };
};