'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactIntl = require('react-intl');

var _cspaceRefname = require('cspace-refname');

var _formatHelpers = require('../../../helpers/formatHelpers');

exports.default = {
  default: [{
    name: 'title',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.group.default.title',
        'defaultMessage': 'Title'
      }
    }),
    sortBy: 'groups_common:title',
    width: 250
  }, {
    name: 'owner',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.group.default.owner',
        'defaultMessage': 'Owner'
      }
    }),
    formatValue: function formatValue(value) {
      return (0, _cspaceRefname.getDisplayName)(value);
    },
    sortBy: 'groups_common:owner',
    width: 400
  }, {
    name: 'updatedAt',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.group.default.updatedAt',
        'defaultMessage': 'Updated'
      }
    }),
    formatValue: _formatHelpers.formatTimestamp,
    sortBy: 'collectionspace_core:updatedAt',
    width: 150
  }]
};