'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactIntl = require('react-intl');

var _formatHelpers = require('../../../helpers/formatHelpers');

var _blobHelpers = require('../../../helpers/blobHelpers');

exports.default = {
  default: [{
    name: 'blobCsid',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.media.default.blobCsid',
        'defaultMessage': 'Thumbnail'
      }
    }),
    formatValue: _blobHelpers.thumbnailImage,
    width: 70
  }, {
    name: 'identificationNumber',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.media.default.identificationNumber',
        'defaultMessage': 'Identification number'
      }
    }),
    sortBy: 'media_common:identificationNumber',
    width: 200
  }, {
    name: 'title',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.media.default.title',
        'defaultMessage': 'Title'
      }
    }),
    sortBy: 'media_common:title',
    width: 380
  }, {
    name: 'updatedAt',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.media.default.updatedAt',
        'defaultMessage': 'Updated'
      }
    }),
    formatValue: _formatHelpers.formatTimestamp,
    sortBy: 'collectionspace_core:updatedAt',
    width: 150
  }],
  narrow: [{
    name: 'blobCsid',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.media.narrow.blobCsid',
        'defaultMessage': 'Thumb'
      }
    }),
    formatValue: _blobHelpers.thumbnailImage,
    width: 70
  }, {
    name: 'identificationNumber',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.media.narrow.identificationNumber',
        'defaultMessage': 'ID'
      }
    }),
    sortBy: 'media_common:identificationNumber',
    width: 200
  }, {
    name: 'title',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.media.narrow.title',
        'defaultMessage': 'Title'
      }
    }),
    sortBy: 'media_common:title',
    width: 380
  }, {
    name: 'updatedAt',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.media.narrow.updatedAt',
        'defaultMessage': 'Updated'
      }
    }),
    formatValue: _formatHelpers.formatTimestamp,
    sortBy: 'collectionspace_core:updatedAt',
    width: 150
  }]
};