'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _reactIntl = require('react-intl');

var _formatHelpers = require('../../../helpers/formatHelpers');

exports.default = {
  default: [{
    name: 'termDisplayName',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.person.default.termDisplayName',
        'defaultMessage': 'Display name'
      }
    }),
    sortBy: 'persons_common:personTermGroupList/0/termDisplayName',
    width: 250
  }, {
    name: 'surName',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.person.default.surName',
        'defaultMessage': 'Surname'
      }
    }),
    sortBy: 'persons_common:personTermGroupList/0/surName',
    width: 125
  }, {
    name: 'foreName',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.person.default.foreName',
        'defaultMessage': 'Forename'
      }
    }),
    sortBy: 'persons_common:personTermGroupList/0/foreName',
    width: 125
  }, {
    name: 'vocabulary',
    dataKey: 'refName',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.person.default.vocabulary',
        'defaultMessage': 'Vocabulary'
      }
    }),
    formatValue: function formatValue(value, formatterContext) {
      return (0, _formatHelpers.formatRefNameAsVocabularyName)(value, formatterContext);
    },
    width: 150
  }, {
    name: 'updatedAt',
    messages: (0, _reactIntl.defineMessages)({
      label: {
        'id': 'column.object.search.updatedAt',
        'defaultMessage': 'Updated'
      }
    }),
    formatValue: _formatHelpers.formatTimestamp,
    sortBy: 'collectionspace_core:updatedAt',
    width: 150
  }]
};